#!/usr/bin/ruby

require 'socket'

DIR="./incoming/"

unless FileTest.directory?(DIR)
	$stderr.print "#{DIR} is not a directory\n"
	exit 1
end

server = TCPServer.new('0.0.0.0',9090)

while (session = server.accept)
	Thread.start(session) do |socket|
		while line = socket.gets
			if line =~ /^FILE:(.*);;SIZE:(.*)$/
				filename = $1
				size = $2.to_i
				$stderr.print "[#{Time.now}] - receiving #{filename} - #{size}\n"
				fd = open(DIR + filename, 'w+')
				
				fd.syswrite(socket.read(size))
				fd.close
			end
		end
		socket.close
	end
end
